-- phpMyAdmin SQL Dump
-- version 3.4.10.1deb1
-- http://www.phpmyadmin.net
--
-- Servidor: localhost
-- Temps de generació: 14-06-2013 a les 21:44:47
-- Versió del servidor: 5.5.28
-- Versió de PHP : 5.3.10-1ubuntu3.4

SET SQL_MODE="NO_AUTO_VALUE_ON_ZERO";
SET time_zone = "+00:00";

--
-- Base de dades: `gestor_pw`
--
CREATE DATABASE `gestor_pw` DEFAULT CHARACTER SET latin1 COLLATE latin1_swedish_ci;
USE `gestor_pw`;

-- --------------------------------------------------------

--
-- Estructura de la taula `accessos`
--

CREATE TABLE IF NOT EXISTS `accessos` (
  `idAcces` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Identificador de l''accés',
  `idUsuari` int(10) unsigned NOT NULL COMMENT 'Identificador de l''usuari',
  `nomServei` varchar(255) NOT NULL COMMENT 'Nom encriptat del servei desat',
  `dadesAcces` varchar(255) NOT NULL COMMENT 'dades d''accés encriptades',
  PRIMARY KEY (`idAcces`),
  KEY `idUsuari` (`idUsuari`)
) ENGINE=InnoDB  DEFAULT CHARSET=latin1 AUTO_INCREMENT=52 ;

-- --------------------------------------------------------

--
-- Estructura de la taula `llavors`
--

CREATE TABLE IF NOT EXISTS `llavors` (
  `idLlavor` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Identificador de la llavor',
  `idUsuari` int(10) unsigned NOT NULL COMMENT 'Identificador de l''usuari',
  `llavor` char(15) NOT NULL COMMENT 'Llavor generada aleatòriament',
  `intents` tinyint(3) unsigned NOT NULL DEFAULT '1' COMMENT 'L''usuari té un màxim de tres intents',
  `dataIntent` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP,
  `ipClient` varchar(15) NOT NULL COMMENT 'IP del client que ha sol·licitat la llavor',
  PRIMARY KEY (`idLlavor`),
  UNIQUE KEY `idUsuari` (`idUsuari`)
) ENGINE=InnoDB  DEFAULT CHARSET=latin1 AUTO_INCREMENT=10 ;

-- --------------------------------------------------------

--
-- Estructura de la taula `usuaris`
--

CREATE TABLE IF NOT EXISTS `usuaris` (
  `idUsuari` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Identificador de l''usuari',
  `usuari` varchar(128) NOT NULL COMMENT 'Hash de l''adreça de correu que és el nom d''usuari',
  `password` varchar(128) NOT NULL COMMENT 'Hash del password',
  `sal` varchar(40) NOT NULL COMMENT 'Sal utilitzada pel client per calcular el hash del password',
  `publica` text COMMENT 'Clau pública',
  `privada` text COMMENT 'Clau privada',
  `activat` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT 'Indica si l''usuari ha activat el seu compte',
  `tipus` tinyint(3) unsigned NOT NULL DEFAULT '2' COMMENT 'Indica el tipus d''usuari (2 - usuari estàndar)',
  `dataAlta` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP COMMENT 'Data en que es va registrar a l''aplicació',
  PRIMARY KEY (`idUsuari`),
  UNIQUE KEY `usuari` (`usuari`)
) ENGINE=InnoDB  DEFAULT CHARSET=latin1 COMMENT='Taula d''usuaris del gestor de contrasenyes' AUTO_INCREMENT=117 ;

--
-- Restriccions per taules bolcades
--

--
-- Restriccions per la taula `accessos`
--
ALTER TABLE `accessos`
  ADD CONSTRAINT `accessos_ibfk_1` FOREIGN KEY (`idUsuari`) REFERENCES `usuaris` (`idUsuari`) ON DELETE CASCADE ON UPDATE CASCADE;

--
-- Restriccions per la taula `llavors`
--
ALTER TABLE `llavors`
  ADD CONSTRAINT `llavors_ibfk_2` FOREIGN KEY (`idUsuari`) REFERENCES `usuaris` (`idUsuari`) ON DELETE CASCADE ON UPDATE CASCADE;

--
-- Usuaris de la base de dades
--
CREATE USER `gestor` IDENTIFIED BY `password`;

GRANT INSERT ON TABLE `gestor_pw`.`usuaris` to gestor;
GRANT UPDATE ON TABLE `gestor_pw`.`usuaris` to gestor;
GRANT DELETE ON TABLE `gestor_pw`.`usuaris` to gestor;
GRANT INSERT ON TABLE `gestor_pw`.`accessos` to gestor;
GRANT UPDATE ON TABLE `gestor_pw`.`accessos` to gestor;
GRANT DELETE ON TABLE `gestor_pw`.`accessos` to gestor;
GRANT INSERT ON TABLE `gestor_pw`.`llavors` to gestor;
GRANT UPDATE ON TABLE `gestor_pw`.`llavors` to gestor;
GRANT DELETE ON TABLE `gestor_pw`.`llavors` to gestor;


