var usr;  // usuari del client
var pwd;  // password del client
var usrHash;  // Hash SHA512 d'usr (equival a 'usari' a la BD)
var hashBF;  // Hash BlowFish del password (equival a 'password' a la BD
var sid;  // Indicador de sessió per aquest client

var serveis = new Array();  // Array on es guardaran els noms dels serveis guardats

var http = getXMLHttpRequest();
var cbk = null;  // Variable auxiliar de la funció callback AJAX per retornar les respostes del servidor a la funció que les demana
var interval;  // Variale auxiliar per funcions setInterval (bcrypt genera hashBF asíncronament i triga)
var bcrypt = new bCrypt();

window.onload = function (){
    try{
    interval = setInterval (enable, 250);
    }catch(e){alert(e);}
};

window.onbeforeunload = function (){
    if (sid != null){
        logout();
        alert ("S'ha tancat la sessió");
    }
};

function enable(){
    if (bcrypt.ready()){
        enableForm(document.getElementById("loginForm"));
        document.getElementById("loginButton").value = "Login";
        clearInterval(interval);
    }
}

function login(){
    
    usr = document.getElementById("user").value;
    pwd = document.getElementById("password").value;
    
    
    if (!checkFields()){
        enableForm (document.getElementById("loginForm"));
        return;
    }
    
    disableForm (document.getElementById("loginForm"));
    setMsg("Sol·licitant autenticació al servidor... Pot trigar uns segons.")
    
    usrHash = CryptoJS.SHA512(usr);
    
    var salt = getSalt();
    if (salt == null){
        enableForm (document.getElementById("loginForm"));
        return;
    }
    
    try{
    bcrypt.hashpw (pwd, salt, continuaLogin, function(){});
    } catch (e){
        alert(e);
    }
}

function continuaLogin(hash){
    
    hashBF = hash;
    
    var seedJson = getSeed();
    
    //alert (seedJson);
    
    if (seedJson == null){
        enableForm (document.getElementById("loginForm"));
        return;
    }
    
    var seedObj = JSON.parse(seedJson);
    
    try{
        
        var hashSeed = CryptoJS.SHA512(hashBF + seedObj.seed);
        
    } catch (e){
        error (e);
    }
    
    sid = getSID(seedObj.idSeed, hashSeed);
    
    if (sid == null){
        enableForm (document.getElementById("loginForm"));
        return;
    }
    
    setMsg("");
    hideForm(document.getElementById("loginForm"));
    hideDiv(document.getElementById("loginDiv"));
    displayDiv(document.getElementById("gestorDiv"));
    displayServices();
    
}

function getSalt(){
    
    var params = {
        task: "getSalt",
        user: usrHash
    }
    
    serverRequest("php/login.php", params);
    var salt = cbk;
    cbk = null  //Resetegem la variable cbk per evitar errors en l'ús de la funció callback

    return salt;
    
}

function getSeed(){
    
    var params = {
        task: "getSeed",
        user: usrHash
    }
    
    serverRequest("php/login.php", params);
    var seed = cbk;
    cbk = null;

    return seed;
    
}

function getSID(idSeed, hash){
    
    var params = {
        task: "getSID",
        user: usrHash,
        idSeed: idSeed,
        hash: hash
    }
    
    serverRequest("php/login.php", params);
    var sessionid = cbk;
    cbk = null;

    return sessionid;
    
}

function save(){
    
    // "id" no tindrà cap valor si estem guardant les dades d'un servei per primer vegada
    // "id" sí tindrà un valor si estem modificant unes dades existents
    
    var id = document.getElementById("saveId").value;
    var servei = document.getElementById("saveSer").value;
    var usrSave = document.getElementById("saveUsr").value;
    var pwdSave = document.getElementById("savePwd").value;
    var pwd2Save = document.getElementById("savePwd2").value;
    
    if (!checkFieldsSave(id, servei, usrSave, pwdSave, pwd2Save)){
        return;
    }
    
    disableForm(document.getElementById("saveForm"));
    
    var objLogin = {
        "usr": usrSave,
        "pwd": pwdSave
    }
    
    var jsonLogin = JSON.stringify(objLogin);
    
    var serveiEnc = encriptaAESJson(servei, pwd);
    var loginEnc = encriptaAESJson(jsonLogin, pwd);
    
    var task;
    
    if (id == ""){
        task = "saveLogin";
    } else {
        task = "updateLogin";
    }
    
    var params = {
        GESTORSESID: sid,
        task: task,
        servei: serveiEnc,
        login: loginEnc,
        id: id
    }
    
    serverRequest("php/app.php", params);
    
    if (cbk == 0){
        setMsg("Dades desades correctament.");
        hideForm(document.getElementById("saveForm"));
        displayServices();
    } else if (cbk == null){
        enableForm(document.getElementById("saveForm"));
    }
    
    return;
    
}

function displayServices(){
    
    setMsg("Carregant serveis...");
    
    var services = getServices();
    
    var servicesArray = JSON.parse(services);
    
    var servicesHTML = "";
    
    if (servicesArray.length > 0){
        
        for (var i=0; i<servicesArray.length; i++){
            var decService = desencriptaAESJson (JSON.stringify (servicesArray[i]), pwd);
            servicesHTML = servicesHTML + "<a href=\"javascript:showLogin(" + servicesArray[i].id + ", \'" + decService + "\')\">" + decService + "</a></br>";
            serveis[i] = decService;
        }
        
        document.getElementById("services").innerHTML = servicesHTML;
        setMsg("");
        return;
        
    }
    
}

function getServices(){
    
    var params = {
        GESTORSESID: sid,
        task: "getServices"
    }
    
    serverRequest("php/app.php", params);
    
    var services = cbk;
    cbk = null;
    
    if (services == null){
        return false;
    }
    
    return services;
    
}

function showLogin(id, name){
    
    var login = getLogin (id);
    
    if (!login){
        return;
    }
    
    var loginDec = desencriptaAESJson (login, pwd);
    
    var loginObj = JSON.parse(loginDec);
    
    hideSave();
    displayForm(document.getElementById("displayForm"));
    document.getElementById("displayId").value = id;
    document.getElementById("displaySer").value = name;
    document.getElementById("displayUsr").value = loginObj.usr;
    document.getElementById("displayPwd").value = loginObj.pwd;
    disableForm(document.getElementById("displayForm"));
    
    return;
    
}

function getLogin(id){
    
    var params = {
        GESTORSESID: sid,
        task: "getLogin",
        id: id
    }
    
    serverRequest("php/app.php", params);

    var login = cbk;
    cbk = null;
    
    if (login == null){
        return false;
    }
    
    return login;
    
}

function modify(){
    
    var id = document.getElementById("displayId").value;
    var n = document.getElementById("displaySer").value;
    var u = document.getElementById("displayUsr").value;
    var p = document.getElementById("displayPwd").value;
    
    hideForm(document.getElementById("displayForm"));
    displaySave();
    document.getElementById("saveId").value = id;
    document.getElementById("saveSer").value = n;
    document.getElementById("saveUsr").value = u;
    document.getElementById("savePwd").value = p
    return;
    
}

function deleteLogin(){
    
    if (!confirm ("Es borrarà aquesta informació i no es podrà recuperar. Vols continuar?")){
        return;
    }
    
    var idLogin = document.getElementById("displayId").value;
    
    var params = {
        GESTORSESID: sid,
        task: "deleteLogin",
        id: idLogin
    }
    
    serverRequest("php/app.php", params);

    var aux = cbk;
    cbk = null;
    
    if (aux == 0){
        setMsg("S'han borrat les dades.");
        hideForm(document.getElementById("displayForm"));
        displayServices();
    }
    
    return;
    
}

function logout(){
    
    var params = {
        GESTORSESID: sid
    }
    
    serverRequest("php/logout.php", params);
    
    sid = null;  // Aquí hauríem d'afegir tota la informació privada carregada durant l'execució
    
    setMsg("");
    hideDiv(document.getElementById("gestorDiv"));
    displayDiv(document.getElementById("loginDiv"));
    displayForm(document.getElementById("loginForm"));
   
}

function remove(){
    
    if (!confirm ("Es borraran tots els teus passwords. Vols continuar?")){
        return;
    }
    
    var params = {
        GESTORSESID: sid,
        task: "removeUsr"
    }
    
    serverRequest("php/app.php", params);
    
    var aux = cbk;
    cbk = null;
    sid = null;
    if (aux == "0"){
        setMsg("S'han eliminat totes les teves dades.");
    } else {
        setMsgErr("Hi ha hagut un error al borrar les dades de l'usuari");
    }
    
    setMsg("");
    hideDiv(document.getElementById("gestorDiv"));
    displayDiv(document.getElementById("loginDiv"));
    displayForm(document.getElementById("loginForm"));
    
    return;
    
}
