var JsonFormatter = {
    stringify: function (cipherParams){
        var jsonObj = {
            ct: cipherParams.ciphertext.toString(CryptoJS.enc.Base64)
        };
        
        if (cipherParams.iv) {
            jsonObj.iv = cipherParams.iv.toString();
        }
        
        if (cipherParams.salt) {
            jsonObj.salt = cipherParams.salt.toString();
        }
        
        return JSON.stringify(jsonObj);
        
    },
    
    parse: function (jsonStr) {
        var jsonObj = JSON.parse(jsonStr);
        
        var cipherParams = CryptoJS.lib.CipherParams.create({
            ciphertext: CryptoJS.enc.Base64.parse(jsonObj.ct)
        });
        
        if (jsonObj.iv) {
            cipherParams.iv = CryptoJS.enc.Hex.parse(jsonObj.iv)
        }
        
        if (jsonObj.salt) {
            cipherParams.salt = CryptoJS.enc.Hex.parse(jsonObj.salt)
        }
        
        return cipherParams;
        
    }
    
};