function registre(){
    
    usuari = document.getElementById("usuari").value;
    password = document.getElementById("password").value;
    password2 = document.getElementById("password2").value;
    
    bcrypt = new bCrypt();
    http = getXMLHttpRequest();
    
    if (!comprovaCamps()){
        
        setFormulari();
        return;
        
    } else {
        
        disableFormulari();
        setStatus ("Guardant dades... Pot trigar uns segons");
        setMissatgeError("");
        
    }
    
    // Calculem el hash de l'adreça de correu electrònic que és l'usuari
    usrHash = CryptoJS.SHA512(usuari);
    
    id = setInterval (genHash, 250);
    
}

function genHash(){
    
    try{
        
        if (bcrypt.ready()){
            
            clearInterval(id);
            
            // Generem els bits de sal que s'afegiran al password per calcular el hash
            sal = bcrypt.gensalt(5);
            
            
            // Calculem el hash del password. guardaHash és la funció callback on es retornarà el hash
            bcrypt.hashpw(password, sal, guardaHash, function(){});
            
        }
        
    }catch (err){
        alertError ("genHash", err);
    }
    
}

function guardaHash (pwdHash){
    
    var params = "tasca=dadesAcces";
    params = params +"&usrHash=" + encodeURIComponent(usrHash);
    params = params + "&sal=" + encodeURIComponent(sal);
    params = params + "&pwdHash=" + encodeURIComponent(pwdHash);
    
    try{

        http.open("POST", "php/registre.php")
        http.onreadystatechange = dadesGuardades;  //dadesGuardades s'executarà en rebre resposta del servidor
        http.setRequestHeader ("Content-type", "application/x-www-form-urlencoded");
        http.send(params);
        
    }catch (err){
        alertError ("guardaHash", err);
    }
    
}

function dadesGuardades(){
    if (http.readyState == 4){
        if (http.status == 200){
            
            var res = http.responseText;
            
            if (res == "0"){
                
                setStatus ("Enviant correu electrònic...");
                setMissatge ("Usuari i password desats correctament");
                setMissatgeError ("");
                enviaCorreu();
                
            } else {
                
                setStatus("Introdueix les teves dades");
                setMissatge ("");
                setMissatgeError (http.responseText);
                setFormulari();
           
            }     
        }
    }
}

function enviaCorreu(){
    
    var url = "php/registre.php?tasca=enviaCorreu&email=" + usuari;
    
    http.open ("GET", url);
    http.onreadystatechange = correuEnviat;
    http.send (null);
    
}

function correuEnviat(){
    if (http.readyState == 4){
        if (http.status == 200){
            
            if (http.responseText == "0"){
                
                setStatus ("Generant claus RSA... Pot trigar uns segons");
                setMissatge ("T'hem enviat un correu amb un enllaç d'activació del teu compte");
                setMissatgeError ("");
                genRSA();
                return;
                
            } else {
                
                setFormulari();
                setStatus("Introdueix les teves dades");
                setMissatge ("");
                setMissatgeError (http.responseText);
                return;
            }
        }
    }
}

function genRSA(){
    
    try{
        var rsa = new RSAKey();
        
        // Generem una clau privada on 1024 són els bits que té la clau i 10001 l'exponent públic
        rsa.generate(1024, "10001");

        var pub = {
            "n": rsa.n.toString(16),
            "e": "10001"
        };

        var pri = {
            "n": rsa.n.toString(16),
            "e": "10001",
            "d": rsa.d.toString(16)
        };

        var publica = JSON.stringify(pub);
        var privada = JSON.stringify(pri);
        
        var priEnc = encriptaAESJson (privada, password);
        
        guardarRSA(publica, priEnc);
        
    } catch (err){
        alertError ("genRSA", err);
    }
}

function guardarRSA(pub, pri){
    
    var params = "tasca=guardaRSA";
    params = params + "&usuari=" + encodeURIComponent(usrHash);
    params = params + "&publica=" + encodeURIComponent(pub);
    params = params + "&privada=" + encodeURIComponent(pri);
    
    http.open ("POST", "php/registre.php");
    http.onreadystatechange = rsaGuardat;
    http.setRequestHeader ("Content-type", "application/x-www-form-urlencoded");
    http.send(params);
    
}

function rsaGuardat(){
    if (http.readyState == 4){
        if (http.status == 200){
            
            if (http.responseText == "0"){
                setStatus ("<a href='home.html'>Login</a>");
                setMissatge ("El procés de registre ha finalitzat correctament.<br/> Després d'activar el teu compte ja pots accedir a l'aplicació.");
                setMissatgeError ("");
                return;
                
            } else {
                setFormulari();
                setStatus("Introdueix les teves dades");
                setMissatge ("");
                setMissatgeError (http.responseText);
                return;
            }
        }
    }
}

// Funció que encripta un string amb AES i retorna un objecte JSON amb
// el text xifrat, la sal per generar la clau, i el iv

function encriptaAESJson (str, pwd){
    
    try{
        
        var sal = CryptoJS.lib.WordArray.random(128/8);
        var iv = CryptoJS.lib.WordArray.random(128/8);
        var clau = CryptoJS.PBKDF2 (pwd, sal, {keySize: 256/32, iterations: 1000});
        
        var enc = CryptoJS.AES.encrypt (str, clau, {'iv': iv, mode: CryptoJS.mode.CBC, padding: CryptoJS.pad.Pkcs7, format: JsonFormatter});
        
        // obj és un objecte javascript sense la sal
        
        var obj = JSON.parse(enc);
        
        // objJS és un objecte javascript amb la sal
        // Recordem que la sal caldrà tornar-la a WordArray per desencriptar
        
        var objJS = {
            
            "ct": obj.ct,
            "iv": obj.iv,
            "sal": CryptoJS.enc.Hex.stringify(sal)
            
        }
        
        var objJson = JSON.stringify (objJS);
        
        return objJson;
        
    } catch (err){
        alert (err);
        return false;
    }
    
}

function comprovaCamps(){
    
    if (usuari == ""){
        setMissatge("");
        setMissatgeError ("Has d'introduïr una adreça de correu electrònic com a usuari");
        return false;
    }
    
    if (!esEmail (usuari)){
        setMissatge("");
        setMissatgeError ("L'usuari no és una adreça de correu electrònic");
        return false;
    }
    
    if (password != password2){
        setMissatge("");
        setMissatgeError ("Les dues contrasenyes no coincideixen");
        return false;
    }
    
    if (!comprovaPassword(password)){return false;}
    
    return true;
    
}

function esEmail(text) {  
  
    var punt = text.substring(text.lastIndexOf('.') + 1, text.length);
    var domini = text.substring(text.lastIndexOf('@') + 1, text.lastIndexOf('.'));
    var usuari = text.substring(0, text.lastIndexOf('@'));
    var reservat = "@⁄º\"\'+*{}\\<>?¿[]áéíóúàèò#·¡!^*;,:";
      
    var valid = true;

    for (i=0; i<usuari.length; i++){
        x = usuari.substring(i,i+1);
        if (reservat.indexOf(x)!=-1){
                    valid = false;
        }
    }
  
    for (i=0; i<punt.length; i++) {
        x=punt.substring(i,i+1);
        if (reservat.indexOf(x)!=-1){
            valid = false;
        }
    }
                          
    for (i=0; i<domini.length; i++) {
        x=domini.substring(i,i+1);
        if (reservat.indexOf(x)!=-1){
            valid = false;
        }
    }
  
    if (punt.length<2 || domini <1 || text.lastIndexOf('.')<0 || text.lastIndexOf('@')<0 || usuari<1) {
        valid = false;
    }
      
    if (!valid) {
        return false;
    }
    
    return true;
}

function comprovaPassword(pwd){
    
    // ATENCIÓ!! - Ho posem a 2 per facilitar les proves, però ha de ser 10
    
    if (pwd.length < 0){
        setMissatgeError ("La contrasenya ha de tenir, com a mínim, 10 caràcters");
        return false;
    }
    
    // ATENCIÓ!! - Ho posem a 1 per facilitar les proves, però ha de ser 50
    
    if (passchk_fast.passEntropy(pwd) < 1){
        setMissatgeError ("La contrasenya no és prou segura. Utilitza una combinació aleatòria de majúscules, minúscules, nombres i símbols per aconseguir que tingui, com a mínim 40 bits d'entropia");
        return false;
    }
    
    return true;   
}

function getXMLHttpRequest(){
    try{
        http = new XMLHttpRequest();
    }catch (err){
        try{
            http = new ActiveXObject("Msxml2.XMLHTTP");
        }catch (err2){
            try{
                http = new ActiveXObject("Microsoft.XMLHTTP");
            }catch (err3){
                http = false;
            }
        }
    }
    
    return http;
}

function setMissatge (str){
    document.getElementById("missatge").innerHTML = str;
}

function setMissatgeError (str){
    document.getElementById("missatgeError").innerHTML = str;
}

function setStatus (str){
    document.getElementById("status").innerHTML = str;
}

function setFormulari(){
    document.getElementById("button").disabled = false;
    document.getElementById("usuari").disabled = false;
    document.getElementById("password").disabled = false;
    document.getElementById("password2").disabled = false;
    document.getElementById("formulari").reset();
    document.getElementById("usuari").focus();
    document.getElementById("fortalesaDiv").style.display = "inline";
}

function disableFormulari(){
    document.getElementById("button").disabled = true;
    document.getElementById("usuari").disabled = true;
    document.getElementById("password").disabled = true;
    document.getElementById("password2").disabled = true;
    document.getElementById("fortalesaDiv").style.display = "none";
}

function alertError (funcio, err){
    alert ("Error a la funció: " + funcio + "\n" + err);
}