function getXMLHttpRequest(){
    try{
        http = new XMLHttpRequest();
    }catch (err){
        try{
            http = new ActiveXObject("Msxml2.XMLHTTP");
        }catch (err2){
            try{
                http = new ActiveXObject("Microsoft.XMLHTTP");
            }catch (err3){
                http = false;
            }
        }
    }
    
    return http;
}

function serverRequest(url, parObj){
    
    var params = "";
    for (property in parObj){
        params = params + property;
        params = params + "=" + encodeURIComponent(parObj[property]) + "&";
    }
    
    cbk = null;
    
    http.open ("POST", url, false);
    http.onreadystatechange = callback;
    http.setRequestHeader ("Content-type", "application/x-www-form-urlencoded");
    http.send (params);
    
}

function callback(){
    if (http.readyState == 4){
        if (http.status == 200){

            if (http.responseText.substring(0,2) == "OK"){
                
                cbk = http.responseText.substring(2);
                
            } else if (http.responseText.substring(0,5) == "ERROR"){
                
                setMsgErr (http.responseText.substring(8));
                
            } else {
                
                setMsgErr("S'ha produït un error no identificat en la resposta del servidor");
            }

            return;
        }
    }
}

function setMsg (str){
    document.getElementById("msg").innerHTML = str;
    document.getElementById("msgErr").innerHTML = "";
}

function setMsgErr (str){
    document.getElementById("msg").innerHTML = "";
    document.getElementById("msgErr").innerHTML = str;
}

function disableForm (form){
    for (i=0;i<form.elements.length;i++)
    {
        form.elements[i].disabled = true;
    }
}

function enableForm (form){
    for (i=0;i<form.elements.length;i++)
    {
        form.elements[i].disabled = false;
    }
}

function hideForm (form){
    form.reset();
    disableForm(form);
    form.style.display = "none";
}

function displayForm (form){
    form.reset();
    form.style.display = "inline";
    enableForm(form);
}

function displaySave(){
    var form = document.getElementById("displayForm");
    hideForm(form);
    var form2 = document.getElementById("saveForm");
    displayForm(form2);
}

function hideSave(){
    var form = document.getElementById("saveForm");
    hideForm(form);
}

function hideDisplay(){
    var form = document.getElementById("displayForm");
    hideForm(form);
}

function hideDiv (div){
    div.style.display = "none";
}

function displayDiv (div){
    div.style.display = "inline";
}

function checkFields(){
    
    if (usr == ""){
        setMsgErr ("Has d'introduïr una adreça de correu electrònic com a usuari");
        return false;
    }
    
    if (!esEmail (usr)){
        setMsgErr ("L'usuari no és una adreça de correu electrònic");
        return false;
    }
    
    if (pwd == ""){
        setMsgErr ("Has d'introduïr la teva contrasenya");
        return false;
    }
    
    return true;
}

function esEmail(text) {  
  
    var punt = text.substring(text.lastIndexOf('.') + 1, text.length);
    var domini = text.substring(text.lastIndexOf('@') + 1, text.lastIndexOf('.'));
    var usuari = text.substring(0, text.lastIndexOf('@'));
    var reservat = "@⁄º\"\'+*{}\\<>?¿[]áéíóúàèò#·¡!^*;,:";
      
    var valid = true;

    for (i=0; i<usuari.length; i++){
        x = usuari.substring(i,i+1);
        if (reservat.indexOf(x)!=-1){
                    valid = false;
        }
    }
  
    for (i=0; i<punt.length; i++) {
        x=punt.substring(i,i+1);
        if (reservat.indexOf(x)!=-1){
            valid = false;
        }
    }
                          
    for (i=0; i<domini.length; i++) {
        x=domini.substring(i,i+1);
        if (reservat.indexOf(x)!=-1){
            valid = false;
        }
    }
  
    if (punt.length<2 || domini <1 || text.lastIndexOf('.')<0 || text.lastIndexOf('@')<0 || usuari<1) {
        valid = false;
    }
      
    if (!valid) {
        return false;
    }
    
    return true;
}

/*
 * Funció que encripta un string amb AES utilitzant el password que se li passa
 * com a paràmetre i retorna un objecte JSON amb el text xifrat,
 * la sal per generar la clau, i el iv.
 */

function checkFieldsSave(id, servei, usrSave, pwdSave, pwd2Save){
    
    if (servei.length == 0){
        setMsgErr("Has d'indicar quin servei vols guardar");
        return false;
    }
    
    if (id == ""){   // Cas que es desin les dades del servei per primera vegada
        for (var i=0; i<serveis.length; i++){  // On serveis és un array que conté els noms dels serveis desats
            if (servei == serveis[i]){
                setMsgErr("Ja has guardat un password per " + servei);
                return false;
            }
        }
    }

    if (usrSave.length == 0){
        setMsgErr("Has d'indicar un usuari per guardar les dades");
        return false;
    }
    
    if (pwdSave.length == 0){
        setMsgErr("Has d'indicar una contrasenya per guardar les dades");
        return false;
    }
    
    if (pwdSave != pwd2Save){
        setMsgErr("Les dues contrasenyes no coincideixen");
        return false;
    }
    
    if (passchk_fast.passCommon(pwdSave)){
       if (!confirm ("La contrasenya es pot considerar comuna i això la pot fer insegura.\n\
            Vols continuar?")){
           return false;
       }
    }
    
    if (passchk_fast.passEntropy (pwdSave) < 40){
        if(!confirm("La contrasenya te menys de 40 bits d'entropia i això la pot fer insegura.\n\
            Vols continuar?")){
            return false;
            }
    }
    
    return true;
    
}

function encriptaAESJson (str, pwd){
    
    try{
        
        var sal = CryptoJS.lib.WordArray.random(128/8);
        var iv = CryptoJS.lib.WordArray.random(128/8);
        var clau = CryptoJS.PBKDF2 (pwd, sal, {keySize: 256/32, iterations: 1000});
        
        var enc = CryptoJS.AES.encrypt (str, clau, {'iv': iv, mode: CryptoJS.mode.CBC, padding: CryptoJS.pad.Pkcs7, format: JsonFormatter});
        
        // obj és un objecte javascript sense la sal
        
        var obj = JSON.parse(enc);
        
        // objJS és un objecte javascript amb la sal
        // Recordem que la sal caldrà tornar-la a WordArray per desencriptar
        
        var objJS = {
            
            "ct": obj.ct,
            "iv": obj.iv,
            "sal": CryptoJS.enc.Hex.stringify(sal)
            
        }
        
        var objJson = JSON.stringify (objJS);
        
        return objJson;
        
    } catch (err){
        alertError ("encriptaAESJson", err);
        return false;
    }
    
}

/*
 * Funció que desencripta amb el password que se li passa un objecte JSON que conté
 * el text xifrat, el iv i la sal per generar la clau
 */

function desencriptaAESJson (objJson, pwd){
    try{
        
        var obj = JSON.parse(objJson);
        var sal  = CryptoJS.enc.Hex.parse(obj.sal);

        //var ct = obj.ct;

        var clau = CryptoJS.PBKDF2 (pwd, sal, {keySize: 256/32, iterations: 1000});

        var b = JsonFormatter.parse(objJson);
        
        var dec = CryptoJS.AES.decrypt (b, clau, {'iv': b.iv, mode: CryptoJS.mode.CBC, padding: CryptoJS.pad.Pkcs7, format: JsonFormatter});

        var serveiDec = dec.toString(CryptoJS.enc.Utf8);
    
    return serveiDec;
    } catch (err){
        alert (err);
    }
}

function getTempsClient(){

   var temps = Math.floor((new Date().getTime())/1000);
   var tempsClient = temps - (temps%15);
   return tempsClient;
   
}

